7 Commits
Author SHA1 Message Date
nortega 87b316fb20 Do not use newline if within parenthesis.
This is useful for some arguments.
2025-10-03 09:13:27 +02:00
nortega 8b125ac5e7 Simplify writing with a write buffer. 2025-10-03 09:07:44 +02:00
nortega 42c0dad3b1 Ignore generated compressed man page. 2025-10-03 06:11:14 +02:00
nortega 49de6d3fd4 Add (un)installation scripts. 2025-10-02 15:44:41 +02:00
nortega 9cc79feefe Add man page. 2025-10-02 15:20:28 +02:00
nortega 2e74ca7976 README: Add more information to the Usage section. 2025-10-02 15:11:58 +02:00
nortega 2884d1dfe6 Correct some language usage in the README. 2025-10-02 15:09:59 +02:00
6 changed files with 123 additions and 18 deletions
+1
View File
@@ -1 +1,2 @@
/target /target
/dbus-prettifier.1.gz
+17 -6
View File
@@ -1,8 +1,8 @@
# DBus Prettifier # DBus Prettifier
I noticed that when working with `qdbus` that I would get long and unformatted I noticed when working with `qdbus` that I would get long and unformatted
outputs that are extremely difficult to read. This small program will prettify a outputs that are extremely difficult to read. This small program will prettify
file with the output so that it is much more readable. a file with the output so that it is much more readable.
## Usage ## Usage
@@ -12,18 +12,29 @@ To run the program, simply run it as follows:
qdbus-prettifier <in-file> [out-file] qdbus-prettifier <in-file> [out-file]
``` ```
## Building If `<in-file>` is defined as `-` this tells the program to read from `stdin`
allowing input to be piped. If the `[out-file]` option is omitted then output is
sent to `stdout`.
For more information, check out the `-h` option.
## Building & Installation
To compile the program, install the Rust suite, namely the compiler and Cargo. To compile the program, install the Rust suite, namely the compiler and Cargo.
Once installed you can run `cargo build --release` to generate a release build Once installed you can run `cargo build --release` to generate a release build
of the project which will be found at `target/release/dbus-prettifier`. of the project which will be found at `target/release/dbus-prettifier`.
To install you can use the `install` command as follows: To install the program you can use the `install` script. By default this will
install to `/usr/local`, but this can be changed by setting the `PREFIX`
variable prior to the command. For example:
```console ```console
install -Dm755 target/release/dbus-prettifier /usr/local/bin PREFIX=/usr ./install
``` ```
Similarly, to uninstall simply run the `uninstall` script. It uses the same
`PREFIX` variable.
## License ## License
This program is licensed under the terms & conditions of the [Zlib This program is licensed under the terms & conditions of the [Zlib
+37
View File
@@ -0,0 +1,37 @@
.TH dbus-prettifier "1" "October 2025" "dbus-prettifier 1.2.0" "User Commands"
.SH "NAME"
dbus-prettifier - A tool to prettify the output of qdbus.
.SH "SYNOPSIS"
.B dbus-prettifier
<\fIin-file\fR> [\fIout-file\fR]
.B dbus-prettifier
\fI-h\fR | \fI-v\fR
.SH "DESCRIPTION"
Takes input from qdbus (either stored in a file or from \fIstdin\fR) and stores
it in the provided \fIout-file\fR.
.SH "ARGUMENTS"
.TP
\fBin-file\fR
File containing qdbus output (if \fI-\fR then input is from \fIstdin\fR)
.TP
\fBout-file\fR
File to write formatted output to (if omitted then \fIstdout\fR is used)
.TP
\fB\-h\fR
Show help information
.TP
\fB\-v\fR
Show version information
.SH "AUTHOR"
Written by Nicolás A. Ortega Froysa.
.SH "COPYRIGHT"
Copyright \(co 2024 Ortega Froysa, Nicolás A. <nicolas@ortegas.org>.
License: ZLib License.
This is free software: you are free to change and redistribute it.
There is NO WARRANTY, to the extent permitted by law.
Executable
+17
View File
@@ -0,0 +1,17 @@
#!/bin/bash
set -euo pipefail
PREFIX=${PREFIX:="/usr/local"}
if ! [ -f "./target/release/dbus-prettifier" ]
then
>&2 echo "Failed to find release target. Please compile the project with 'cargo build --release'."
exit 1
fi
gzip -k ./dbus-prettifier.1
install -Dm644 ./dbus-prettifier.1.gz "$PREFIX/share/man/man1/"
install -Dm755 ./target/release/dbus-prettifier "$PREFIX/bin/"
rm -f ./dbus-prettifier.1.gz
+35 -9
View File
@@ -27,6 +27,8 @@ use std::fs;
use std::io::Read; use std::io::Read;
use std::boxed::Box; use std::boxed::Box;
static MAX_WRITE_BUF_SIZE:usize = 1024;
pub fn work(in_path:Option<&str>, out_path:Option<&str>) -> Result<(), String> { pub fn work(in_path:Option<&str>, out_path:Option<&str>) -> Result<(), String> {
let in_reader:Box<dyn io::Read> = match in_path { let in_reader:Box<dyn io::Read> = match in_path {
Some(path) => { Some(path) => {
@@ -56,33 +58,43 @@ pub fn work(in_path:Option<&str>, out_path:Option<&str>) -> Result<(), String>
let mut last_ch = '\0'; let mut last_ch = '\0';
let mut tab_num = 0; let mut tab_num = 0;
let mut in_paren = false;
let mut write_buf = String::new();
for i in in_reader.bytes() { for i in in_reader.bytes() {
let ch = i.unwrap() as char; let ch = i.unwrap() as char;
match ch { match ch {
'[' | '{' => { '[' | '{' => {
tab_num += 1; tab_num += 1;
out_writer.write(format!("{ch}\n").as_bytes()).unwrap(); //write_buf += format!("{ch}\n").as_str();
write_buf.push(ch);
if !in_paren {
write_buf.push('\n');
for _ in 0..tab_num { for _ in 0..tab_num {
out_writer.write(b" ").unwrap(); write_buf += " ";
} }
last_ch = ' '; last_ch = ' ';
} else {
last_ch = ch;
}
}, },
']' | '}' => { ']' | '}' => {
tab_num -= 1; tab_num -= 1;
out_writer.write(b"\n").unwrap(); if !in_paren {
write_buf += "\n";
for _ in 0..tab_num { for _ in 0..tab_num {
out_writer.write(b" ").unwrap(); write_buf += " ";
} }
out_writer.write(format!("{ch}").as_bytes()).unwrap(); }
write_buf.push(ch);
last_ch = ch; last_ch = ch;
}, },
',' => { ',' => {
out_writer.write(format!("{ch}").as_bytes()).unwrap(); write_buf.push(ch);
if last_ch == '}' || last_ch == ']' { if last_ch == '}' || last_ch == ']' {
out_writer.write(b"\n").unwrap(); write_buf.push('\n');
for _ in 0..tab_num { for _ in 0..tab_num {
out_writer.write(b" ").unwrap(); write_buf += " ";
} }
last_ch = ' '; last_ch = ' ';
} else { } else {
@@ -91,11 +103,25 @@ pub fn work(in_path:Option<&str>, out_path:Option<&str>) -> Result<(), String>
}, },
_ => { _ => {
if ch != ' ' || last_ch != ' ' { if ch != ' ' || last_ch != ' ' {
out_writer.write(format!("{ch}").as_bytes()).unwrap(); if ch == '(' {
in_paren = true;
} else if ch == ')' {
in_paren = false;
}
write_buf.push(ch);
last_ch = ch; last_ch = ch;
} }
}, },
} }
if write_buf.len() >= MAX_WRITE_BUF_SIZE {
out_writer.write_all(write_buf.as_bytes()).unwrap();
write_buf.clear();
}
}
if write_buf.len() > 0 {
out_writer.write_all(write_buf.as_bytes()).unwrap();
} }
Ok(()) Ok(())
Executable
+13
View File
@@ -0,0 +1,13 @@
#!/bin/bash
set -euo pipefail
PREFIX=${PREFIX:="/usr/local"}
if ! [ -f "$PREFIX/bin/dbus-prettifier" ]
then
>&2 echo "Installation not found in prefix '$PREFIX'."
exit 1
fi
rm -f "$PREFIX/bin/dbus-prettifier"
rm -f "$PREFIX/share/man/man1/dbus-prettifier.1.gz"